Index: branches/HeuristicLab.Hive-3.4/sources/HeuristicLab.Clients.Hive.Slave.SlaveTrayIcon/MainWindow.Designer.cs
===================================================================
--- branches/HeuristicLab.Hive-3.4/sources/HeuristicLab.Clients.Hive.Slave.SlaveTrayIcon/MainWindow.Designer.cs	(revision 6257)
+++ branches/HeuristicLab.Hive-3.4/sources/HeuristicLab.Clients.Hive.Slave.SlaveTrayIcon/MainWindow.Designer.cs	(revision 6263)
@@ -36,4 +36,6 @@
       this.tabSlaveView = new System.Windows.Forms.TabPage();
       this.slaveView = new HeuristicLab.Clients.Hive.SlaveCore.Views.SlaveView();
+      this.tabJobs = new System.Windows.Forms.TabPage();
+      this.jobsView = new HeuristicLab.Clients.Hive.SlaveCore.Views.JobsView();
       this.tabLog = new System.Windows.Forms.TabPage();
       this.logView = new HeuristicLab.Clients.Hive.SlaveCore.Views.LogView();
@@ -43,4 +45,5 @@
       this.mainTabControl.SuspendLayout();
       this.tabSlaveView.SuspendLayout();
+      this.tabJobs.SuspendLayout();
       this.tabLog.SuspendLayout();
       this.tabAbout.SuspendLayout();
@@ -98,14 +101,14 @@
       // mainTabControl
       // 
-      this.mainTabControl.Anchor = ((System.Windows.Forms.AnchorStyles)((((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Bottom)
-                  | System.Windows.Forms.AnchorStyles.Left)
-                  | System.Windows.Forms.AnchorStyles.Right)));
       this.mainTabControl.Controls.Add(this.tabSlaveView);
+      this.mainTabControl.Controls.Add(this.tabJobs);
       this.mainTabControl.Controls.Add(this.tabLog);
       this.mainTabControl.Controls.Add(this.tabAbout);
-      this.mainTabControl.Location = new System.Drawing.Point(12, 12);
+      this.mainTabControl.Dock = System.Windows.Forms.DockStyle.Fill;
+      this.mainTabControl.Location = new System.Drawing.Point(0, 0);
+      this.mainTabControl.Margin = new System.Windows.Forms.Padding(1);
       this.mainTabControl.Name = "mainTabControl";
       this.mainTabControl.SelectedIndex = 0;
-      this.mainTabControl.Size = new System.Drawing.Size(581, 369);
+      this.mainTabControl.Size = new System.Drawing.Size(605, 393);
       this.mainTabControl.TabIndex = 1;
       // 
@@ -116,5 +119,5 @@
       this.tabSlaveView.Name = "tabSlaveView";
       this.tabSlaveView.Padding = new System.Windows.Forms.Padding(3);
-      this.tabSlaveView.Size = new System.Drawing.Size(573, 343);
+      this.tabSlaveView.Size = new System.Drawing.Size(597, 367);
       this.tabSlaveView.TabIndex = 0;
       this.tabSlaveView.Text = "Overview";
@@ -131,6 +134,29 @@
       this.slaveView.Name = "slaveView";
       this.slaveView.ReadOnly = false;
-      this.slaveView.Size = new System.Drawing.Size(561, 331);
+      this.slaveView.Size = new System.Drawing.Size(585, 355);
       this.slaveView.TabIndex = 0;
+      // 
+      // tabJobs
+      // 
+      this.tabJobs.Controls.Add(this.jobsView);
+      this.tabJobs.Location = new System.Drawing.Point(4, 22);
+      this.tabJobs.Name = "tabJobs";
+      this.tabJobs.Size = new System.Drawing.Size(597, 367);
+      this.tabJobs.TabIndex = 3;
+      this.tabJobs.Text = "Jobs";
+      this.tabJobs.UseVisualStyleBackColor = true;
+      // 
+      // jobsView
+      // 
+      this.jobsView.Anchor = ((System.Windows.Forms.AnchorStyles)((((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Bottom)
+                  | System.Windows.Forms.AnchorStyles.Left)
+                  | System.Windows.Forms.AnchorStyles.Right)));
+      this.jobsView.Caption = "JobsView";
+      this.jobsView.Content = null;
+      this.jobsView.Location = new System.Drawing.Point(4, 4);
+      this.jobsView.Name = "jobsView";
+      this.jobsView.ReadOnly = false;
+      this.jobsView.Size = new System.Drawing.Size(590, 360);
+      this.jobsView.TabIndex = 0;
       // 
       // tabLog
@@ -140,5 +166,5 @@
       this.tabLog.Name = "tabLog";
       this.tabLog.Padding = new System.Windows.Forms.Padding(3);
-      this.tabLog.Size = new System.Drawing.Size(573, 277);
+      this.tabLog.Size = new System.Drawing.Size(597, 367);
       this.tabLog.TabIndex = 1;
       this.tabLog.Text = "Log";
@@ -155,5 +181,5 @@
       this.logView.Name = "logView";
       this.logView.ReadOnly = false;
-      this.logView.Size = new System.Drawing.Size(560, 264);
+      this.logView.Size = new System.Drawing.Size(584, 352);
       this.logView.TabIndex = 0;
       // 
@@ -163,5 +189,5 @@
       this.tabAbout.Location = new System.Drawing.Point(4, 22);
       this.tabAbout.Name = "tabAbout";
-      this.tabAbout.Size = new System.Drawing.Size(573, 277);
+      this.tabAbout.Size = new System.Drawing.Size(577, 347);
       this.tabAbout.TabIndex = 2;
       this.tabAbout.Text = "About HeuristicLab Hive";
@@ -178,5 +204,5 @@
       this.aboutView.Name = "aboutView";
       this.aboutView.ReadOnly = false;
-      this.aboutView.Size = new System.Drawing.Size(567, 271);
+      this.aboutView.Size = new System.Drawing.Size(571, 275);
       this.aboutView.TabIndex = 0;
       // 
@@ -187,5 +213,4 @@
       this.ClientSize = new System.Drawing.Size(605, 393);
       this.Controls.Add(this.mainTabControl);
-      this.FormBorderStyle = System.Windows.Forms.FormBorderStyle.FixedSingle;
       this.Icon = ((System.Drawing.Icon)(resources.GetObject("$this.Icon")));
       this.Name = "MainWindow";
@@ -195,4 +220,5 @@
       this.mainTabControl.ResumeLayout(false);
       this.tabSlaveView.ResumeLayout(false);
+      this.tabJobs.ResumeLayout(false);
       this.tabLog.ResumeLayout(false);
       this.tabAbout.ResumeLayout(false);
@@ -216,4 +242,6 @@
     private System.Windows.Forms.ToolStripSeparator toolStripSeparator;
     private System.Windows.Forms.ToolStripMenuItem homepageToolStripMenuItem;
+    private System.Windows.Forms.TabPage tabJobs;
+    private Views.JobsView jobsView;
   }
 }
Index: branches/HeuristicLab.Hive-3.4/sources/HeuristicLab.Clients.Hive.Slave.SlaveTrayIcon/MainWindow.cs
===================================================================
--- branches/HeuristicLab.Hive-3.4/sources/HeuristicLab.Clients.Hive.Slave.SlaveTrayIcon/MainWindow.cs	(revision 6257)
+++ branches/HeuristicLab.Hive-3.4/sources/HeuristicLab.Clients.Hive.Slave.SlaveTrayIcon/MainWindow.cs	(revision 6263)
@@ -12,4 +12,5 @@
         slaveView.Content = value;
         logView.Content = value;
+        jobsView.Content = value;
         Content.UserVisibleMessageFired += new EventHandler<Common.EventArgs<string>>(Content_UserVisibleMessageFired);
       }
@@ -58,8 +59,4 @@
         e.Cancel = true;
         MinimizeToTray();
-      } else {
-        if (Content != null) {
-          Content.StopAll();
-        }
       }
     }
@@ -72,6 +69,4 @@
       System.Diagnostics.Process.Start("http://dev.heuristiclab.com");
     }
-
-
   }
 }