Index: anches/WebApplication/MVC2/HeuristicLabWeb.PluginHost/HLWebPluginHost/Controllers/AlgorithmClassController.cs
===================================================================
--- /branches/WebApplication/MVC2/HeuristicLabWeb.PluginHost/HLWebPluginHost/Controllers/AlgorithmClassController.cs	(revision 6274)
+++ 	(revision )
@@ -1,66 +1,0 @@
-﻿using System;
-using System.Collections.Generic;
-using System.Linq;
-using System.Web;
-using System.Web.Mvc;
-using System.ServiceModel.Security;
-using HLWebPluginHost.Models;
-
-namespace HLWebPluginHost.Controllers
-{
-    public class AlgorithmClassController : Controller
-    {
-        //
-        // GET: /AlgorithmClass/
-
-        public ActionResult Index() {
-            //create list of algorithms
-            //OKBService.OKBServiceClient sc = new OKBService.OKBServiceClient();
-            //sc.ClientCredentials.UserName.UserName = "Gerhard";
-            //sc.ClientCredentials.UserName.Password = "Gerhard";
-            //sc.ClientCredentials.ServiceCertificate.Authentication.CertificateValidationMode = X509CertificateValidationMode.None;
-
-            //var agcList = new List<OKBService.AlgorithmClass>();
-            //OKBService.AlgorithmClass[] ac = sc.GetAlgorithmClasses();
-            //foreach (OKBService.AlgorithmClass a in ac) {
-            //    agcList.Add(a);
-            //}//foreach
-
-            //var viewModel = new AlgorithmClassModel {
-            //    NumOfClasses = agcList.Count(),
-            //    AlgorithmClassList = agcList
-            //};
-
-            var viewModel = new AlgorithmClassModel {
-                NumOfClasses = 0,
-                AlgorithmClassList = null
-            };
-
-            return View(viewModel);
-        }//index
-
-        //
-        // GET: /AlgorithmClass/Browse
-
-        public string Browse() {
-            string message = "AlgorithmClass.Browse, id = " + Server.HtmlEncode(Request.QueryString["id"]);
-            return Server.HtmlEncode(message);
-        }//index
-
-        //
-        // GET: /AlgorithmClass/Details/2
-
-        public string Details(int id) {
-            string message = "AlgorithmClass.Details, id = " + id;
-            return Server.HtmlEncode(message);
-        }//index
-
-        //
-        // GET: /AlgotithmClass/5
-        public string DelAlgorithmClass(int id){
-            string message = "DeleteAlgorithmClass, id = " + Server.HtmlEncode(Request.QueryString["id"]);
-            return Server.HtmlEncode(message);
-        }
-
-    }
-}
Index: anches/WebApplication/MVC2/HeuristicLabWeb.PluginHost/HLWebPluginHost/Controllers/ServicePrototypeController.cs
===================================================================
--- /branches/WebApplication/MVC2/HeuristicLabWeb.PluginHost/HLWebPluginHost/Controllers/ServicePrototypeController.cs	(revision 6274)
+++ 	(revision )
@@ -1,132 +1,0 @@
-﻿using System;
-using System.Collections.Generic;
-using System.Linq;
-using System.Web;
-using System.Web.Mvc;
-using System.Diagnostics;
-using System.ServiceModel.Security;
-using System.Web.Security;
-
-namespace HLWebPluginHost.Controllers
-{
-    public class ServicePrototypeController : Controller
-    {
-       
-        //
-        // GET: /ServicePrototype/
-
-        public ActionResult Index()
-        {
-
-            OKBService.OKBServiceClient sc = new OKBService.OKBServiceClient();
-            //sc.ClientCredentials.UserName.UserName = Membership.GetUser().UserName;
-            //sc.ClientCredentials.UserName.Password = Membership.GetUser().GetPassword();
-            sc.ClientCredentials.UserName.UserName = "Gerhard";
-            sc.ClientCredentials.UserName.Password = "Gerhard";
-            sc.ClientCredentials.ServiceCertificate.Authentication.CertificateValidationMode = X509CertificateValidationMode.None;
-            
-            //read algorithm class entries
-            Debug.WriteLine("algorithm class entries");
-            OKBService.AlgorithmClass[] ac = sc.GetAlgorithmClasses();
-            foreach (OKBService.AlgorithmClass i in ac) {
-                Debug.WriteLine(i.Name);
-            }
-            
-
-            //read problem class entries
-            Debug.WriteLine("problem class entries");
-            OKBService.ProblemClass[] pc = sc.GetProblemClasses();
-            foreach (OKBService.ProblemClass i in pc) {
-                Debug.WriteLine(i.Name);
-            }
-            sc.Close();
-            return View();
-        }
-
-        //
-        // GET: /ServicePrototype/Details/5
-
-        public ActionResult Details(int id)
-        {
-            return View();
-        }
-
-        //
-        // GET: /ServicePrototype/Create
-
-        public ActionResult Create()
-        {
-            return View();
-        } 
-
-        //
-        // POST: /ServicePrototype/Create
-
-        [HttpPost]
-        public ActionResult Create(FormCollection collection)
-        {
-            try
-            {
-                // TODO: Add insert logic here
-
-                return RedirectToAction("Index");
-            }
-            catch
-            {
-                return View();
-            }
-        }
-        
-        //
-        // GET: /ServicePrototype/Edit/5
- 
-        public ActionResult Edit(int id)
-        {
-            return View();
-        }
-
-        //
-        // POST: /ServicePrototype/Edit/5
-
-        [HttpPost]
-        public ActionResult Edit(int id, FormCollection collection)
-        {
-            try
-            {
-                // TODO: Add update logic here
- 
-                return RedirectToAction("Index");
-            }
-            catch
-            {
-                return View();
-            }
-        }
-
-        //
-        // GET: /ServicePrototype/Delete/5
- 
-        public ActionResult Delete(int id)
-        {
-            return View();
-        }
-
-        //
-        // POST: /ServicePrototype/Delete/5
-
-        [HttpPost]
-        public ActionResult Delete(int id, FormCollection collection)
-        {
-            try
-            {
-                // TODO: Add delete logic here
- 
-                return RedirectToAction("Index");
-            }
-            catch
-            {
-                return View();
-            }
-        }
-    }
-}