Index: /branches/WebApplication/MVC2/HLWebOKBAdminPlugin/Controllers/AdminController.cs
===================================================================
--- /branches/WebApplication/MVC2/HLWebOKBAdminPlugin/Controllers/AdminController.cs	(revision 6289)
+++ /branches/WebApplication/MVC2/HLWebOKBAdminPlugin/Controllers/AdminController.cs	(revision 6290)
@@ -10,4 +10,5 @@
 using HLWebOKBAdminPlugin.Helpers;
 using HLWebOKBAdminPlugin.Models;
+using System.Reflection;
 
 namespace HLWebOKBAdminPlugin.Controllers {
@@ -28,4 +29,5 @@
 
         public ActionResult Menu() {
+            
             return View();
         }//ActionResult Men
Index: /branches/WebApplication/MVC2/HLWebOKBAdminPlugin/Controllers/AlgorithmClassController.cs
===================================================================
--- /branches/WebApplication/MVC2/HLWebOKBAdminPlugin/Controllers/AlgorithmClassController.cs	(revision 6289)
+++ /branches/WebApplication/MVC2/HLWebOKBAdminPlugin/Controllers/AlgorithmClassController.cs	(revision 6290)
@@ -14,6 +14,6 @@
         // GET: /AlgorithmClass/
 
-        public ActionResult Index()
-        {
+        public ActionResult Index() {
+
             Session["SelectedSubMenu"] = "AlgorithmClass";
             AlgorithmClassModel acm = new AlgorithmClassModel();
Index: /branches/WebApplication/MVC2/HLWebOKBAdminPlugin/Properties/AssemblyInfo.cs
===================================================================
--- /branches/WebApplication/MVC2/HLWebOKBAdminPlugin/Properties/AssemblyInfo.cs	(revision 6289)
+++ /branches/WebApplication/MVC2/HLWebOKBAdminPlugin/Properties/AssemblyInfo.cs	(revision 6290)
@@ -37,7 +37,5 @@
 [assembly: AssemblyVersion("1.0.0.0")]
 [assembly: AssemblyFileVersion("1.0.0.0")]
-[assembly: WebResource("HLWebOKBAdminPlugin.Resources.Delete.bmp", "image/bmp")]
-[assembly: WebResource("HLWebOKBAdminPlugin.Resources.Plus.bmp", "image/bmp")]
-[assembly: WebResource("HLWebOKBAdminPlugin.Resources.Update.bmp", "image/bmp")]
+
 [assembly: HLWebPluginViewLocations(
     new string[] { "~/Plugins/HLWebOKBAdminPlugin.dll/HLWebOKBAdminPlugin.Views.{1}.{0}.aspx", "~/Plugins/HLWebOKBAdminPlugin.dll/HLWebOKBAdminPlugin.Views.{1}.{0}.ascx" },
Index: /branches/WebApplication/MVC2/HLWebOKBAdminPlugin/Views/Algorithm/Detail.aspx
===================================================================
--- /branches/WebApplication/MVC2/HLWebOKBAdminPlugin/Views/Algorithm/Detail.aspx	(revision 6289)
+++ /branches/WebApplication/MVC2/HLWebOKBAdminPlugin/Views/Algorithm/Detail.aspx	(revision 6290)
@@ -5,4 +5,7 @@
 <asp:Content ID="Content1" ContentPlaceHolderID="TitleContent" runat="server">
     Detail
+</asp:Content>
+<asp:Content ID="Content3" runat="server" ContentPlaceHolderID="SubMenuContent">
+   <% Html.RenderAction("Menu", "Admin"); %>
 </asp:Content>
 <asp:Content ID="Content2" ContentPlaceHolderID="MainContent" runat="server">
Index: /branches/WebApplication/MVC2/HLWebOKBAdminPlugin/Views/Algorithm/Index.aspx
===================================================================
--- /branches/WebApplication/MVC2/HLWebOKBAdminPlugin/Views/Algorithm/Index.aspx	(revision 6289)
+++ /branches/WebApplication/MVC2/HLWebOKBAdminPlugin/Views/Algorithm/Index.aspx	(revision 6290)
@@ -4,39 +4,47 @@
 <%@ Import Namespace="HLWebOKBAdminPlugin.OKBAdministrationService" %>
 <asp:Content ID="Content1" ContentPlaceHolderID="TitleContent" runat="server">
-    Index
+  Index
+</asp:Content>
+<asp:Content ID="Content3" runat="server" ContentPlaceHolderID="SubMenuContent">
+  <% Html.RenderAction("Menu", "Admin"); %>
 </asp:Content>
 <asp:Content ID="Content2" ContentPlaceHolderID="MainContent" runat="server">
-    <h2>Algorithms</h2>
-    
-    
-    
-    <%  long? id = null;  %>
-    <%: Html.ActionLink("New Algorithm", "Detail", new {id}) %>
-    <%: Html.ActionLink("Order ASC", "SortAsc")%>
-    <%: Html.ActionLink("Order DESC", "SortDesc")%>
-
-    <div style="height:150px; overflow:scroll;">
-        <table>
-            <!--// We get this from the Controller (Index)-->
-            <% foreach(Algorithm p in ((AlgorithmModel)Model).Algorithms) {  %>
-            <tr>
-                <td>
-                    <%: Html.Label(p.Name)%>
-                </td>
-                <td>
-                    <%: Html.Label(p.Description) %>
-                </td>
-                <td>
-                    <%: Html.Label(p.DataTypeName)%>
-                </td>
-                <td>
-                    <%: Html.ActionLink("detail", "Detail",new {p.Id}) %>
-                </td>
-                <td>
-                    <%: Html.ActionLink("delete", "Delete",new {p.Id}) %>
-                </td>
-            </tr>
-            <% } %>
-        </table>
-    </div>       
+  <h2>
+    Algorithms</h2>
+  <%  long? id = null;  %>
+  <div class="hl-menuButtons">
+  <%: Html.ActionLink("New Algorithm", "Detail", new { id }, new { @class = "hl-button-text-plus" })%>
+  </div>
+  <table class="hl-dataTable">
+    <thead>
+      <tr>
+        <th>Name</th>
+        <th>Description</th>
+        <th>Type</th>
+        <th colspan="2">Actions</th>
+      </tr>
+    </thead>
+    <tbody>
+      <!--// We get this from the Controller (Index)-->
+      <% foreach (Algorithm p in ((AlgorithmModel)Model).Algorithms) {  %>
+      <tr>
+        <td>
+          <%: Html.Label(p.Name)%>
+        </td>
+        <td>
+          <%: Html.Label(p.Description) %>
+        </td>
+        <td>
+          <%: Html.Label(p.DataTypeName)%>
+        </td>
+        <td>
+          <%: Html.ActionLink("detail", "Detail", new { p.Id }, new { @class = "hl-icon-edit" })%>
+        </td>
+        <td>
+          <%: Html.ActionLink("delete", "Delete", new { p.Id }, new { @class = "hl-icon-delete" })%>
+        </td>
+      </tr>
+      <% } %>
+    </tbody>
+  </table>
 </asp:Content>
Index: /branches/WebApplication/MVC2/HLWebOKBAdminPlugin/Views/AlgorithmClass/Detail.aspx
===================================================================
--- /branches/WebApplication/MVC2/HLWebOKBAdminPlugin/Views/AlgorithmClass/Detail.aspx	(revision 6289)
+++ /branches/WebApplication/MVC2/HLWebOKBAdminPlugin/Views/AlgorithmClass/Detail.aspx	(revision 6290)
@@ -5,4 +5,7 @@
 <asp:Content ID="Content1" ContentPlaceHolderID="TitleContent" runat="server">
     Detail
+</asp:Content>
+<asp:Content ID="Content3" runat="server" ContentPlaceHolderID="SubMenuContent">
+   <% Html.RenderAction("Menu", "Admin"); %>
 </asp:Content>
 <asp:Content ID="Content2" ContentPlaceHolderID="MainContent" runat="server">
Index: /branches/WebApplication/MVC2/HLWebOKBAdminPlugin/Views/AlgorithmClass/Index.aspx
===================================================================
--- /branches/WebApplication/MVC2/HLWebOKBAdminPlugin/Views/AlgorithmClass/Index.aspx	(revision 6289)
+++ /branches/WebApplication/MVC2/HLWebOKBAdminPlugin/Views/AlgorithmClass/Index.aspx	(revision 6290)
@@ -4,9 +4,10 @@
 <%@ Import Namespace="HLWebOKBAdminPlugin.OKBAdministrationService" %>
 
-
 <asp:Content ID="Content1" ContentPlaceHolderID="TitleContent" runat="server">
     Index
 </asp:Content>
-
+<asp:Content ID="Content3" runat="server" ContentPlaceHolderID="SubMenuContent">
+   <% Html.RenderAction("Menu", "Admin"); %>
+</asp:Content>
 <asp:Content ID="Content2" ContentPlaceHolderID="MainContent" runat="server">
 
Index: /branches/WebApplication/MVC2/HLWebOKBAdminPlugin/Views/Problem/Detail.aspx
===================================================================
--- /branches/WebApplication/MVC2/HLWebOKBAdminPlugin/Views/Problem/Detail.aspx	(revision 6289)
+++ /branches/WebApplication/MVC2/HLWebOKBAdminPlugin/Views/Problem/Detail.aspx	(revision 6290)
@@ -5,4 +5,7 @@
 <asp:Content ID="Content1" ContentPlaceHolderID="TitleContent" runat="server">
     Detail
+</asp:Content>
+<asp:Content ID="Content3" runat="server" ContentPlaceHolderID="SubMenuContent">
+   <% Html.RenderAction("Menu", "Admin"); %>
 </asp:Content>
 <asp:Content ID="Content2" ContentPlaceHolderID="MainContent" runat="server">
Index: /branches/WebApplication/MVC2/HLWebOKBAdminPlugin/Views/Problem/Index.aspx
===================================================================
--- /branches/WebApplication/MVC2/HLWebOKBAdminPlugin/Views/Problem/Index.aspx	(revision 6289)
+++ /branches/WebApplication/MVC2/HLWebOKBAdminPlugin/Views/Problem/Index.aspx	(revision 6290)
@@ -5,4 +5,7 @@
 <asp:Content ID="Content1" ContentPlaceHolderID="TitleContent" runat="server">
     Index
+</asp:Content>
+<asp:Content ID="Content3" runat="server" ContentPlaceHolderID="SubMenuContent">
+   <% Html.RenderAction("Menu", "Admin"); %>
 </asp:Content>
 <asp:Content ID="Content2" ContentPlaceHolderID="MainContent" runat="server">
Index: /branches/WebApplication/MVC2/HLWebOKBAdminPlugin/Views/ProblemClass/Detail.aspx
===================================================================
--- /branches/WebApplication/MVC2/HLWebOKBAdminPlugin/Views/ProblemClass/Detail.aspx	(revision 6289)
+++ /branches/WebApplication/MVC2/HLWebOKBAdminPlugin/Views/ProblemClass/Detail.aspx	(revision 6290)
@@ -6,4 +6,7 @@
 <asp:Content ID="Content1" ContentPlaceHolderID="TitleContent" runat="server">
 	Detail
+</asp:Content>
+<asp:Content ID="Content3" runat="server" ContentPlaceHolderID="SubMenuContent">
+   <% Html.RenderAction("Menu", "Admin"); %>
 </asp:Content>
 <asp:Content ID="Content2" ContentPlaceHolderID="MainContent" runat="server">
Index: /branches/WebApplication/MVC2/HLWebOKBAdminPlugin/Views/ProblemClass/Index.aspx
===================================================================
--- /branches/WebApplication/MVC2/HLWebOKBAdminPlugin/Views/ProblemClass/Index.aspx	(revision 6289)
+++ /branches/WebApplication/MVC2/HLWebOKBAdminPlugin/Views/ProblemClass/Index.aspx	(revision 6290)
@@ -8,5 +8,7 @@
 	Index
 </asp:Content>
-
+<asp:Content ID="Content3" runat="server" ContentPlaceHolderID="SubMenuContent">
+   <% Html.RenderAction("Menu", "Admin"); %>
+</asp:Content>
 <asp:Content ID="Content2" ContentPlaceHolderID="MainContent" runat="server">
 
Index: /branches/WebApplication/MVC2/HLWebOKBAdminPlugin/Views/Shared/Site.Master
===================================================================
--- /branches/WebApplication/MVC2/HLWebOKBAdminPlugin/Views/Shared/Site.Master	(revision 6289)
+++ /branches/WebApplication/MVC2/HLWebOKBAdminPlugin/Views/Shared/Site.Master	(revision 6290)
@@ -4,37 +4,38 @@
 <html xmlns="http://www.w3.org/1999/xhtml">
 <head runat="server">
-    <title><asp:ContentPlaceHolder ID="TitleContent" runat="server" /></title>
-    <link href="../../Content/Site.css" rel="stylesheet" type="text/css" />
+  <title>
+    <asp:ContentPlaceHolder ID="TitleContent" runat="server" />
+  </title>
+  <link href="../../Content/Site.css" rel="stylesheet" type="text/css" />
 </head>
+<body>
+  <div class="page">
+    <div id="header">
+      <div id="title">
+        <h1>
+          My MVC Application</h1>
+      </div>
+      <div id="logindisplay">
+        <% Html.RenderPartial("LogOnUserControl"); %>
+      </div>
+      <div id="menucontainer">
+        <ul id="menu">
+          <li>
+            <%: Html.ActionLink("Home", "Index", "Home")%></li>
+          <li>
+            <%: Html.ActionLink("About", "About", "Home")%></li>
+        </ul>
+      </div>
+    </div>
 
-<body>
-    <div class="page">
-
-        <div id="header">
-            <div id="title">
-                <h1>My MVC Application</h1>
-            </div>
-              
-            <div id="logindisplay">
-                <% Html.RenderPartial("LogOnUserControl"); %>
-            </div> 
-            
-            <div id="menucontainer">
-            
-                <ul id="menu">              
-                    <li><%: Html.ActionLink("Home", "Index", "Home")%></li>
-                    <li><%: Html.ActionLink("About", "About", "Home")%></li>
-                </ul>
-            
-            </div>
-        </div>
-
-        <div id="main">
-            <asp:ContentPlaceHolder ID="MainContent" runat="server" />
-
-            <div id="footer">
-            </div>
-        </div>
+    <div id="main">
+        <div id="master-submenu">
+      <asp:ContentPlaceHolder ID="SubMenuContent" runat="server" />
     </div>
+      <asp:ContentPlaceHolder ID="MainContent" runat="server" />
+      <div id="footer">
+      </div>
+    </div>
+  </div>
 </body>
 </html>